#include <91M55800.H>                    /* AT91M55800A definitions           */
#include <stdio.h>                       /* standard I/O .h-file              */

#define VREF  3                          /* number of records              */

void main (void)  {                             /* main entry for program      */

unsigned int adval;

/* Setup APMC */
  APMC_PCER = (1<<PIOA_ID) | (1<<PIOB_ID) |    /* enable PIOA, PIOB,          */
              (1<<ADC0_ID) | (1<<US0_ID);      /*        ADC0, US0,           */

  PIOA_OER = 1;                                /* Set PA0 as Output           */

/* Initialize the serial interface  */
  PIOA_PDR = (1<<PIORXD0) | (1<<PIOTXD0);  /* Enable RXD0 and TXD0            */
  US0_MR   = US_CHRL_8 | US_PAR_NO;        /* 8 bits, no Parity, 1 Stop bit   */
  US0_BRGR = 208;                          /* 9600 Baud Rate @ 32 MHz Clock   */
  US0_CR   = US_RXEN | US_TXEN;            /* Enable RX and TX                */

/* Setup the A/D converter */
  ADC0_CR = ADC_SWRST;                         /* reset ADC0                  */
  ADC0_CHER = ADC_CH0 | ADC_CH1 | ADC_CH2 | ADC_CH3;  /* enable AD0..3        */
  ADC0_MR = ADC_10_BIT_RES | (9<<ADC_B_PRESCAL);      /* setup ADC0           */

  while (1)  {                                 /* loop forever                */

    ADC0_CR = ADC_START;                       /* start ADC0 conversion       */
    while ((ADC0_SR & ADC_EOC0) == 0);         /* wait for ADC0 conversion    */

/* Read result of ADC0 conversion   */
      adval = (unsigned int) ADC0_CDR0;

/* Output 0-1023 ADC0 value without using floating-point */
  //printf ("ADC0 Count %4u = %01u.%04u Volts\r",
  //       (unsigned) adval,
  //       (unsigned) (adval * VREF) >> 10,                          /* Output Integer Portion */
  //       (unsigned) ((adval * VREF * 10000UL) >> 10UL) % 10000);   /* Output Decimal Portion */
  }
}
